import 'dart:async';
import 'dart:io';

import 'package:roundtripper/src/response.dart';

class CancelToken {
  late Completer<ErrorResponse> _completer;

  CancelToken() {
    _completer = Completer<ErrorResponse>();
  }

  static bool isCancel(ErrorResponse e) {
    return e.statusCode == HttpStatus.clientClosedRequest;
  }

  Future<ErrorResponse> get whenCancel => _completer.future;

  ErrorResponse? _cancelError;

  ErrorResponse? get cancelError => _cancelError;

  /// Cancel the request
  void cancel([dynamic reason]) {
    _cancelError = ErrorResponse(
      HttpStatus.clientClosedRequest,
      reason: reason,
    );
    if (!_completer.isCompleted) {
      _completer.complete(cancelError);
    }
  }
}
